# This function implements LS-based ASF and weighted bootstrap inference.

# This version: June 2019.


#====================================================================
#
#				                     ESTIMATION        
#            
#====================================================================


resQR     <- strucfuncs(Y = Y, X = X, Z = Z, R = R, methodASF="LS", taus1 = taus1, taus2 = taus2, qY = qY, gridX = gridX, FS = "QR", QDSF = NULL)$ASF
asffitQR  <- resQR

nobs  	   <- length(Y);


# ===================================================================
#                                           
#  			                     INFERENCE                   
#                                           
# ===================================================================


if(length(se) > 0){
  
if(length(qYbar)>0){ ngridY <- length(qYbar) }
  

#--------------------------------------------------------------------
# Weighted bootstrap
#--------------------------------------------------------------------

# QR s.e.
  asf.bootsQR    <- matrix(0, ngridX, B)

  QRse <- foreach(s = 1:B, .packages = c("quantreg"), .options.RNG = seed) %dorng% { 
                  strucfuncs(Y = Y, X = X, Z = Z, R = R, methodASF="LS", taus1 = taus1, taus2 = taus2, qY = qY, gridX = gridX, FS = "QR", QDSF = NULL, weights = wboots[,s])$ASF
  }

for(s in 1:B){ asf.bootsQR[,s] <- QRse[[s]] }


print("QRse done !")



#--------------------------------------------------------------------
# Store results
#--------------------------------------------------------------------

sd.asfQR          <- matrix(0, ngridX, 1)                            
sd.asfDR          <- matrix(0, ngridX, 1)                          
K.asfQR           <- matrix(0, c(ngridX, B))                
K.asfDR           <- matrix(0, c(ngridX, B))                

# s.d.
 sd.asfQR <- apply(asf.bootsQR, 1, IQR, na.rm = T)/1.349

# t-stat

  K.asfQR           <- (asf.bootsQR - matrix(asffitQR, ngridX, B, byrow = F)) / matrix(sd.asfQR, ngridX, B, byrow = F)
  tnstaraQR         <- K.asfQR 
  Kmax.asfQR 	      <- apply(tnstaraQR, 2, FUN = max, na.rm = T);
  Kalpha.asfQR      <- quantile(Kmax.asfQR, 1 - alphab);
    
  asf.lbwQR         <- asffitQR - Kalpha.asfQR * sd.asfQR;
  asf.ubwQR         <- asffitQR + Kalpha.asfQR * sd.asfQR;
  
}


#===============================================================================
# Save results
#===============================================================================

  results           <- list()
  results$QR <- resQR 
  if(length(se) > 0){
    results$asf.lbwQR  <- asf.lbwQR
    results$asf.ubwQR  <- asf.ubwQR
  }
  

  if(length(R) == 0){ save(results, file = paste("LSASFResults_",good,"_",sample,"_ngFS",ntaus1,"_ngSS",ntaus2,"_nx",ngridX,"t",100*trim[1],"_qY",100*qY[1],".RData",sep="") ) }
  if(length(R) > 0){  save(results, file = paste("LSASFResultspm_",good,"_",sample,"_ngFS",ntaus1,"_ngSS",ntaus2,"_nx",ngridX,"t",100*trim[1],"_qY",100*qY[1],".RData",sep="") ) }


  
rm(ls="results")


