# Routines for structural functions plots.

sfuncsplot <- function(results,ngx,yy,Qreg=T,resultsLS=NULL){
    
  #results$tausqsf <- tausqsf
  gridX.DR        <- results$DR$gridX
  #gridX.DR        <- results$QR$gridX
  #stopifnot(length(which(results$tausqsf==tausqsf))>0)
  #xx.DR          <- seq(gridX.DR[1],gridX.DR[length(results$DR$gridX)],length.out = ngx)
  xx              <- seq(gridX.DR[1],gridX.DR[length(results$DR$gridX)],length.out = ngx)
  #pY              <- seq(.01,.99,length.out = ngy)
  #yy              <- quantile(Y,pY)
  
  # ---------------------------
  # Define
  # ---------------------------
  #ASFs
  asfDRfun      <- splinefun(gridX.DR,results$DR$ASF, method = "natural")
  asfDRfun.lbw  <- splinefun(gridX.DR,results$asf.lbwDR, method = "natural")
  asfDRfun.ubw  <- splinefun(gridX.DR,results$asf.ubwDR, method = "natural")
  if(length(resultsLS)>0){
    asfLSfun      <- splinefun(gridX.DR,resultsLS$QR, method = "natural")
    asfLSfun.lbw  <- splinefun(gridX.DR,resultsLS$asf.lbwQR, method = "natural")
    asfLSfun.ubw  <- splinefun(gridX.DR,resultsLS$asf.ubwQR, method = "natural")
  }
  if(length(Qreg)>0){
  asfQRfun      <- splinefun(gridX.DR,results$QR$ASF, method = "natural")
  asfQRfun.lbw  <- splinefun(gridX.DR,results$asf.lbwQR, method = "natural")
  asfQRfun.ubw  <- splinefun(gridX.DR,results$asf.ubwQR, method = "natural")
  }
  
  # QSFs
  if(length(Qreg)>0){
  qsfQRfun      <- list()
  qsfQRfun.lbw  <- list()
  qsfQRfun.ubw  <- list()
  }
  qsfDRfun      <- list()
  qsfDRfun.lbw  <- list()
  qsfDRfun.ubw  <- list()
  
  for(i in 1:ntausqsf){
    if(length(Qreg)>0){
    qsfQRfun[[i]]     <- splinefun(gridX.DR,results$QR$QSF[,i], method = "natural")
    qsfQRfun.lbw[[i]] <- splinefun(gridX.DR,results$qsf.lbwQR[,i], method = "natural")
    qsfQRfun.ubw[[i]] <- splinefun(gridX.DR,results$qsf.ubwQR[,i], method = "natural")
    }
    qsfDRfun[[i]]     <- splinefun(gridX.DR,results$DR$QSF[,i], method = "natural")
    qsfDRfun.lbw[[i]] <- splinefun(gridX.DR,results$qsf.lbwDR[,i], method = "natural")
    qsfDRfun.ubw[[i]] <- splinefun(gridX.DR,results$qsf.ubwDR[,i], method = "natural")
    }
  
  # DSFs
  dsfDRfun      <- list()
  dsfQRfun      <- list()
  dsfDRfun.lbw  <- list()
  dsfQRfun.lbw  <- list()
  dsfDRfun.ubw  <- list()
  dsfQRfun.ubw  <- list()

  for(i in 1:length(gridX.DR)){
    if(length(Qreg)>0){
    dsfQRfun[[i]]     <- splinefun(yy,results$QR$DSF[,i], method = "monoH.FC")
    dsfQRfun.lbw[[i]] <- splinefun(yy,results$dsf.lbwQR[,i], method = "monoH.FC")
    dsfQRfun.ubw[[i]] <- splinefun(yy,results$dsf.ubwQR[,i], method = "monoH.FC")
    }
    dsfDRfun[[i]]     <- splinefun(yy,results$DR$DSF[,i], method = "monoH.FC")
    dsfDRfun.lbw[[i]] <- splinefun(yy,results$dsf.lbwDR[,i], method = "monoH.FC")
    dsfDRfun.ubw[[i]] <- splinefun(yy,results$dsf.ubwDR[,i], method = "monoH.FC")
  }
  
  # ---------------------------
  # Evaluate
  # ---------------------------
  # ASFs
  asfDRfunx      <- asfDRfun(xx)
  asfDRfunx.lbw  <- asfDRfun.lbw(xx)
  asfDRfunx.ubw  <- asfDRfun.ubw(xx)
  if(length(resultsLS)>0){
  asfLSfunx      <- asfLSfun(xx)
  asfLSfunx.lbw  <- asfLSfun.lbw(xx)
  asfLSfunx.ubw  <- asfLSfun.ubw(xx)
  }
  if(length(Qreg)>0){
  asfQRfunx      <- asfQRfun(xx)
  asfQRfunx.lbw  <- asfQRfun.lbw(xx)
  asfQRfunx.ubw  <- asfQRfun.ubw(xx)
  }
  
  # QSFs
  qsfDRfunx      <- NULL
  qsfDRfunx.lbw  <- NULL
  qsfDRfunx.ubw  <- NULL
  qsfQRfunx      <- NULL
  qsfQRfunx.lbw  <- NULL
  qsfQRfunx.ubw  <- NULL
  
  if(length(Qreg)>0){
  for(i in 1:ntausqsf){ qsfQRfunx     <- c(qsfQRfunx,     qsfQRfun[[i]](xx)) }
  for(i in 1:ntausqsf){ qsfQRfunx.lbw <- c(qsfQRfunx.lbw, qsfQRfun.lbw[[i]](xx)) }
  for(i in 1:ntausqsf){ qsfQRfunx.ubw <- c(qsfQRfunx.ubw, qsfQRfun.ubw[[i]](xx)) }
  }
  for(i in 1:ntausqsf){ qsfDRfunx     <- c(qsfDRfunx,     qsfDRfun[[i]](xx)) }
  for(i in 1:ntausqsf){ qsfDRfunx.lbw <- c(qsfDRfunx.lbw, qsfDRfun.lbw[[i]](xx)) }
  for(i in 1:ntausqsf){ qsfDRfunx.ubw <- c(qsfDRfunx.ubw, qsfDRfun.ubw[[i]](xx)) }
  
  # DSFs
  dsfDRfunx      <- NULL
  dsfDRfunx.lbw  <- NULL
  dsfDRfunx.ubw  <- NULL
  dsfQRfunx      <- NULL
  dsfQRfunx.lbw  <- NULL
  dsfQRfunx.ubw  <- NULL
  
  if(length(Qreg)>0){
  for(i in 1:length(gridX.DR)){ dsfQRfunx     <- c(dsfQRfunx,     dsfQRfun[[i]](yy)) }
  for(i in 1:length(gridX.DR)){ dsfQRfunx.lbw <- c(dsfQRfunx.lbw, dsfQRfun.lbw[[i]](yy)) }
  for(i in 1:length(gridX.DR)){ dsfQRfunx.ubw <- c(dsfQRfunx.ubw, dsfQRfun.ubw[[i]](yy)) }
  }
  for(i in 1:length(gridX.DR)){ dsfDRfunx     <- c(dsfDRfunx,     dsfDRfun[[i]](yy)) }
  for(i in 1:length(gridX.DR)){ dsfDRfunx.lbw <- c(dsfDRfunx.lbw, dsfDRfun.lbw[[i]](yy)) }
  for(i in 1:length(gridX.DR)){ dsfDRfunx.ubw <- c(dsfDRfunx.ubw, dsfDRfun.ubw[[i]](yy)) }
  
  
  
  ans <- list(asfDRfunx = asfDRfunx, asfDRfunx.lbw = asfDRfunx.lbw, asfDRfunx.ubw = asfDRfunx.ubw,
              qsfDRfunx = qsfDRfunx, qsfDRfunx.lbw = qsfDRfunx.lbw, qsfDRfunx.ubw = qsfDRfunx.ubw, 
              dsfDRfunx = dsfDRfunx, dsfDRfunx.lbw = dsfDRfunx.lbw, dsfDRfunx.ubw = dsfDRfunx.ubw)
  if(length(Qreg)>0){
  ans <- list(asfDRfunx = asfDRfunx, asfDRfunx.lbw = asfDRfunx.lbw, asfDRfunx.ubw = asfDRfunx.ubw,
              asfQRfunx = asfQRfunx, asfQRfunx.lbw = asfQRfunx.lbw, asfQRfunx.ubw = asfQRfunx.ubw,
              qsfDRfunx = qsfDRfunx, qsfDRfunx.lbw = qsfDRfunx.lbw, qsfDRfunx.ubw = qsfDRfunx.ubw, 
              qsfQRfunx = qsfQRfunx, qsfQRfunx.lbw = qsfQRfunx.lbw, qsfQRfunx.ubw = qsfQRfunx.ubw,
              dsfDRfunx = dsfDRfunx, dsfDRfunx.lbw = dsfDRfunx.lbw, dsfDRfunx.ubw = dsfDRfunx.ubw, 
              dsfQRfunx = dsfQRfunx, dsfQRfunx.lbw = dsfQRfunx.lbw, dsfQRfunx.ubw = dsfQRfunx.ubw)
  }
  if(length(resultsLS)>0){
  ans <- list(asfDRfunx = asfDRfunx, asfDRfunx.lbw = asfDRfunx.lbw, asfDRfunx.ubw = asfDRfunx.ubw,
              asfLSfunx = asfLSfunx, asfLSfunx.lbw = asfLSfunx.lbw, asfLSfunx.ubw = asfLSfunx.ubw,
              asfQRfunx = asfQRfunx, asfQRfunx.lbw = asfQRfunx.lbw, asfQRfunx.ubw = asfQRfunx.ubw,
              qsfDRfunx = qsfDRfunx, qsfDRfunx.lbw = qsfDRfunx.lbw, qsfDRfunx.ubw = qsfDRfunx.ubw, 
              qsfQRfunx = qsfQRfunx, qsfQRfunx.lbw = qsfQRfunx.lbw, qsfQRfunx.ubw = qsfQRfunx.ubw,
              dsfDRfunx = dsfDRfunx, dsfDRfunx.lbw = dsfDRfunx.lbw, dsfDRfunx.ubw = dsfDRfunx.ubw, 
              dsfQRfunx = dsfQRfunx, dsfQRfunx.lbw = dsfQRfunx.lbw, dsfQRfunx.ubw = dsfQRfunx.ubw)
  }
  
  return(ans) 
}

