# This is the main file for MC simulations.

# This version: June 2019.

#rm(list=ls())

library(MASS)
library(foreign);
library(quantreg);
library(doParallel)
library(doRNG)
library(speedglm)
registerDoParallel(makeCluster(detectCores()))			 
getDoParWorkers()                                        # Sanity check


#setwd("")

source("BinLib.R")
source("mainfuncs.R")
source("rearrangement.R")
source("drfunc.R")


# Which sample ?
sample        <- "pool"


#====================================================================================
# General settings : same across simulations
#====================================================================================

# General
#---------------------------------------

#link          <- "logit"                  # Link function for distribution regression
link          <- "probit"                  # Link function for distribution regression
rSS           <- 0                        # Rearranged DR-based DSF = 0. 
eps           <- 0.01 
trim          <- c(0,1)
ngridX        <- 5;
ntaus         <- 599
ngridY        <- ntaus
ntaus1        <- ntaus;                      # number of QR grid points in first stage
ntaus2        <- ntaus;                      # number of QR grid points in second stage
#qY            <- seq(eps, 1-eps, length.out = ngridY)
qY            <- seq(0, 1, length.out = ngridY)
taus1         <- seq(eps, 1-eps, length.out = ntaus1)              
taus2         <- seq(eps, 1-eps, length.out = ntaus2);
tausqsf       <- c(.25, .5, .75);                # Quantiles of interest for the QSF
ntausqsf      <- length(tausqsf)
tauqr         <- tausqsf
integration   <- "Smplave"

#set.seed(999)
nrep 	        <- 500					         # Number of replications




# ==================================================
#                                    
#          Simulations                
#                                    
# ==================================================



good          <- "Leisure"


nsim          <- 1655           		 # Simulated sample size


rho           <- -0.2

source('MC_Main_Setup_nose_template.R')

rm(results)


rho           <- -0.9

source('MC_Main_Setup_nose_template.R')

rm(results)


