# This file produces Tables 1 and 2 in the Supplementary Material 

#rm(list=ls())

library(quantreg)

setwd("")


########################
load("SimResults_Leisure_1655_probit_-0.2_ng599_nx5.Rdata")

ngridx            <- length(results_sim$Xgridsim)
tausqsf           <- results_sim$tausqsf;      # Quantiles of interest for the QSF
ntausqsf          <- length(tausqsf)

# RMSE
RMSE.QSF.loc      <- results_sim$RMSE.loc
RMSE.QSF.qr       <- results_sim$RMSE.qr
RMSE.QSF.dr       <- results_sim$RMSE.dr
RMSE.ASF.loc      <- results_sim$RMSE.ASF.loc
RMSE.ASF.qr       <- results_sim$RMSE.ASF.qr
RMSE.ASF.dr       <- results_sim$RMSE.ASF.dr

# Store results
# ------------------------------------------------
#QSF
#latex.table(round(1000*RMSE.QSF.loc[-4,,1], digit=1), file = paste(c("RMSEloc_1655_rho2_ng599_nx5_tau=.25")), caption = "RMSEloc_1655_rho2_ng599_nx5_tau=.25", sep = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.loc[-4,,2], digit=1), file = paste(c("RMSEloc_1655_rho2_ng599_nx5_tau=.5")), caption = "RMSEloc_1655_rho2_ng599_nx5_tau=.5", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.loc[-4,,3], digit=1), file = paste(c("RMSEloc_1655_rho2_ng599_nx5_tau=.75")), caption = "RMSEloc_1655_rho2_ng599_nx5_tau=.75", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.qr[-4,,1], digit=1), file = paste(c("RMSEqr_1655_rho2_ng599_nx5_tau=.25")), caption = "RMSEqr_1655_rho2_ng599_nx5_tau=.25", sep = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.qr[-4,,2], digit=1), file = paste(c("RMSEqr_1655_rho2_ng599_nx5_tau=.5")), caption = "RMSEqr_1655_rho2_ng599_nx5_tau=.5", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.qr[-4,,3], digit=1), file = paste(c("RMSEqr_1655_rho2_ng599_nx5_tau=.75")), caption = "RMSEqr_1655_rho2_ng599_nx5_tau=.75", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.dr[-4,,1], digit=1), file = paste(c("RMSEdr_1655_rho2_ng599_nx5_tau=.25")), caption = "RMSEdr_1655_rho2_ng599_nx5_tau=.25", sep = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.dr[-4,,2], digit=1), file = paste(c("RMSEdr_1655_rho2_ng599_nx5_tau=.5")), caption = "RMSEdr_1655_rho2_ng599_nx5_tau=.5", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.dr[-4,,3], digit=1), file = paste(c("RMSEdr_1655_rho2_ng599_nx5_tau=.75")), caption = "RMSEdr_1655_rho2_ng599_nx5_tau=.75", collapse = "", dec = 5)
latex.table(cbind(round(1000*RMSE.QSF.qr[-4,,1], digit=1),round(1000*RMSE.QSF.loc[-4,,1], digit=1),round(1000*RMSE.QSF.dr[-4,,1], digit=1)), file = paste(c("RMSE_QSF25_1655_rho2_ng599_nx5_probit")), caption = "RMSE_QSF25_1655_rho2_ng599_nx5_probit", sep = "", dec = 5)
latex.table(cbind(round(1000*RMSE.QSF.qr[-4,,2], digit=1),round(1000*RMSE.QSF.loc[-4,,2], digit=1),round(1000*RMSE.QSF.dr[-4,,2], digit=1)), file = paste(c("RMSE_QSF50_1655_rho2_ng599_nx5_probit")), caption = "RMSE_QSF50_1655_rho2_ng599_nx5_probit", sep = "", dec = 5)
latex.table(cbind(round(1000*RMSE.QSF.qr[-4,,3], digit=1),round(1000*RMSE.QSF.loc[-4,,3], digit=1),round(1000*RMSE.QSF.dr[-4,,3], digit=1)), file = paste(c("RMSE_QSF75_1655_rho2_ng599_nx5_probit")), caption = "RMSE_QSF75_1655_rho2_ng599_nx5_probit", sep = "", dec = 5)
# ASF
#latex.table(round(1000*RMSE.ASF.loc, digit=1), file = paste(c("RMSEloc_ASF_1655_rho2_ng599_nx5")), caption = "RMSEloc_ASF_1655_rho2_ng599_nx5", sep = "", dec = 5)
#latex.table(round(1000*RMSE.ASF.qr, digit=1), file = paste(c("RMSEqr_ASF_1655_rho2_ng599_nx5")), caption = "RMSEqr_ASF_1655_rho2_ng599_nx5", sep = "", dec = 5)
#latex.table(round(1000*RMSE.ASF.dr, digit=1), file = paste(c("RMSEdr_ASF_1655_rho2_ng599_nx5")), caption = "RMSEdr_ASF_1655_rho2_ng599_nx5", sep = "", dec = 5)
latex.table(cbind(round(1000*RMSE.ASF.qr, digit=1),round(1000*RMSE.ASF.loc, digit=1),round(1000*RMSE.ASF.dr, digit=1)), file = paste(c("RMSE_ASF_1655_rho2_ng599_nx5_probit")), caption = "RMSE_ASF_1655_rho2_ng599_nx5_probit", sep = "", dec = 5)
            
rm(list = ls())
####################################

load("SimResults_Leisure_1655_probit_-0.9_ng599_nx5.Rdata")

ngridx            <- length(results_sim$Xgridsim)
tausqsf           <- results_sim$tausqsf;      # Quantiles of interest for the QSF
ntausqsf          <- length(tausqsf)

# RMSE
RMSE.QSF.loc      <- results_sim$RMSE.loc
RMSE.QSF.qr       <- results_sim$RMSE.qr
RMSE.QSF.dr       <- results_sim$RMSE.dr
RMSE.ASF.loc      <- results_sim$RMSE.ASF.loc
RMSE.ASF.qr       <- results_sim$RMSE.ASF.qr
RMSE.ASF.dr       <- results_sim$RMSE.ASF.dr

# Store results
# ------------------------------------------------
#QSF
#latex.table(round(1000*RMSE.QSF.loc[-4,,1], digit=1), file = paste(c("RMSEloc_1655_rho9_ng599_nx5_tau=.25")), caption = "RMSEloc_1655_rho9_ng599_nx5_tau=.25", sep = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.loc[-4,,2], digit=1), file = paste(c("RMSEloc_1655_rho9_ng599_nx5_tau=.5")), caption = "RMSEloc_1655_rho9_ng599_nx5_tau=.5", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.loc[-4,,3], digit=1), file = paste(c("RMSEloc_1655_rho9_ng599_nx5_tau=.75")), caption = "RMSEloc_1655_rho9_ng599_nx5_tau=.75", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.qr[-4,,1], digit=1), file = paste(c("RMSEqr_1655_rho9_ng599_nx5_tau=.25")), caption = "RMSEqr_1655_rho9_ng599_nx5_tau=.25", sep = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.qr[-4,,2], digit=1), file = paste(c("RMSEqr_1655_rho9_ng599_nx5_tau=.5")), caption = "RMSEqr_1655_rho9_ng599_nx5_tau=.5", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.qr[-4,,3], digit=1), file = paste(c("RMSEqr_1655_rho9_ng599_nx5_tau=.75")), caption = "RMSEqr_1655_rho9_ng599_nx5_tau=.75", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.dr[-4,,1], digit=1), file = paste(c("RMSEdr_1655_rho9_ng599_nx5_tau=.25")), caption = "RMSEdr_1655_rho9_ng599_nx5_tau=.25", sep = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.dr[-4,,2], digit=1), file = paste(c("RMSEdr_1655_rho9_ng599_nx5_tau=.5")), caption = "RMSEdr_1655_rho9_ng599_nx5_tau=.5", collapse = "", dec = 5)
#latex.table(round(1000*RMSE.QSF.dr[-4,,3], digit=1), file = paste(c("RMSEdr_1655_rho9_ng599_nx5_tau=.75")), caption = "RMSEdr_1655_rho9_ng599_nx5_tau=.75", collapse = "", dec = 5)
latex.table(cbind(round(1000*RMSE.QSF.qr[-4,,1], digit=1),round(1000*RMSE.QSF.loc[-4,,1], digit=1),round(1000*RMSE.QSF.dr[-4,,1], digit=1)), file = paste(c("RMSE_QSF25_1655_rho9_ng599_nx5_probit")), caption = "RMSE_QSF25_1655_rho9_ng599_nx5_probit", sep = "", dec = 5)
latex.table(cbind(round(1000*RMSE.QSF.qr[-4,,2], digit=1),round(1000*RMSE.QSF.loc[-4,,2], digit=1),round(1000*RMSE.QSF.dr[-4,,2], digit=1)), file = paste(c("RMSE_QSF50_1655_rho9_ng599_nx5_probit")), caption = "RMSE_QSF50_1655_rho9_ng599_nx5_probit", sep = "", dec = 5)
latex.table(cbind(round(1000*RMSE.QSF.qr[-4,,3], digit=1),round(1000*RMSE.QSF.loc[-4,,3], digit=1),round(1000*RMSE.QSF.dr[-4,,3], digit=1)), file = paste(c("RMSE_QSF75_1655_rho9_ng599_nx5_probit")), caption = "RMSE_QSF75_1655_rho9_ng599_nx5_probit", sep = "", dec = 5)
# ASF
#latex.table(round(1000*RMSE.ASF.loc, digit=1), file = paste(c("RMSEloc_ASF_1655_rho9_ng599_nx5")), caption = "RMSEloc_ASF_1655_rho9_ng599_nx5", sep = "", dec = 5)
#latex.table(round(1000*RMSE.ASF.qr, digit=1), file = paste(c("RMSEqr_ASF_1655_rho9_ng599_nx5")), caption = "RMSEqr_ASF_1655_rho9_ng599_nx5", sep = "", dec = 5)
#latex.table(round(1000*RMSE.ASF.dr, digit=1), file = paste(c("RMSEdr_ASF_1655_rho9_ng599_nx5")), caption = "RMSEdr_ASF_1655_rho9_ng599_nx5", sep = "", dec = 5)
latex.table(cbind(round(1000*RMSE.ASF.qr, digit=1),round(1000*RMSE.ASF.loc, digit=1),round(1000*RMSE.ASF.dr, digit=1)), file = paste(c("RMSE_ASF_1655_rho9_ng599_nx5_probit")), caption = "RMSE_ASF_1655_rho9_ng599_nx5_probit", sep = "", dec = 5)

#rm(list = ls())



